% dsp02_ex_deterministic.m
clear all; close all;

fs=100; Nx=100;                 % sampling frequency, number of samples
dt = 1/fs;                      % sampling period 
t = dt*(0:Nx-1);                % sampling times (many moments)
x1=sin(2*pi*10*t+pi/4);         % sine 10 Hz as a first signal component
x2=sin(2*pi*1*t);               % sine 1 Hz
x3=exp(-5*t);                   % exponent decaying in time 
x4=exp(-25*(t-0.5)).^2;         % Gaussian hat
x5=sin(2*pi*(0*t+0.5*20*t.^2)); % linear frequency increase: start 0 Hz, +20Hz/s
x6=sin(2*pi*(10*t-(10/(2*pi*1)*cos(2*pi*1*t))));  % sinusoidal FM
x7=sin(2*pi*(10*t+10*cumsum(x2)*dt));             % the same as x6; why?
x = x1;                         % our choice: x1,x2,...,x7, 0.23*x1 + x2, x1.*x3, ... 
plot(t,x,'o-'); grid; title('Signal x(t)'); xlabel('time [s]'); ylabel('Amplitude');