
% lab05_ex_butterfly_in_a_loop.m
% Radix-2 decimation in time (DIT) FFT algorithm
clear all; close all;

N=8;                  % number of signal samples (power of 2 required)
x=0:N-1;              % exemplary analyzed signal
Nbit=log2(N);         % number of bits for sample indexes, e.g. N=8, Nbit=3

%Samples reordering (in bitreverse fashion)
for n=0:N-1
    nc = n;                      % old sample position - copying
    m = 0;                       % new sample position - initialization
    for k=1:Nbit                 % check all bits
        if(rem(n,2)==1)          % check low significant bit
           m = m + 2^(Nbit-k);   % accumulate "m" using bitreversed weight
           n = n - 1;            % decrement by 1
        end
        n=n/2;                   % shift all bits one position right 
    end
    y(m+1) = x(nc+1);            % copy sample into new "bitreversed" position
end
y, pause                         % check result

% Butterflies
Nlev=Nbit;                       % number of levels
for lev=1:Nlev % LEVELS
    bw=2^(lev-1);                % butterflies width
    nbb=2^(lev-1);               % number of butterflies per block
    sbb=2^lev;                   % shift between blocks
    nbl=N/2^lev;                 % number of blocks
    W=exp(-j*2*pi/2^lev);        % correction coefficient
    for bu=1:nbb % BUTTERFLIES
        Wb=W^(bu-1);                             % correction for given butterfly
        for bl=1:nbl % BLOCKS
            up   = 1    + (bu-1) + (bl-1)*sbb;   % up sample index
            down = 1+bw + (bu-1) + (bl-1)*sbb;   % down sample index
            temp = Wb * y(down);                 % temporary value
            y(down) = y(up) - temp;              % new down sample
            y(up)   = y(up) + temp;              % new up sample
        end
    end    
end

ERROR = max( abs( fft(x) - y ) ), pause
