% dsp06_ex_fftapps_tf.m - FFT application for time-varying signals
% observing many consecutive spectra - tracking of frequency change in time
clear all; close all;

N  = 1000;                                  % number of signal samples
fs = 1000;                                  % sampling ratio (Hz)
dt=1/fs; t=dt*(0:N-1);                      % time axis
x = exp( j*2*pi*(0*t + 0.5*(fs/2)*t.^2));   % LFM signal
spectrogram(x,128,128-16,256,fs); pause     % its STFT

xx = x .* conj(x(end:-1:1));                % Wigner kernel of x(n)
X = fft( xx )/N;                            % FFT
stem( abs( X ) );                           % only one frequency is detected