% dsp09_ex_window.m - design of FIR filters using window method
clear all; close all;

% Parameters
fs = 2000;       % sampling frequency
f0 = 100;        % cut-off frequency for low-pass and high-pass filters
f1 = 400;        % low frequency for band-pass and band-stop filters
f2 = 600;        % high frequency for band-pass and band-stop filters
M = 100;         % half of the filter weights
N = 2*M + 1;     % number of weights {b(n)} - always odd
n = -M :1: M;    % non-causal weights indexes

% Impulse responses - weights
hALL = zeros(1,N); hALL(M+1)=1;                        % AllPass
hLP = sin(2*pi*f0/fs*n)./(pi*n); hLP(M+1) = 2*f0/fs;   % LowPass f0
hHP = hALL - hLP;                                      % HighPass
hLP1 = sin(2*pi*f1/fs*n)./(pi*n); hLP1(M+1) = 2*f1/fs; % LowPass f1
hLP2 = sin(2*pi*f2/fs*n)./(pi*n); hLP2(M+1) = 2*f2/fs; % LowPass f2
hBP = hLP2 - hLP1;                                     % BandPass [f1,f2]
%hBS = ?;                                              % BandStop [f1,f2]
b = hLP;                                               % choose: hLP, hHP, hBP, hBS
stem( n, b ); title('b(n)'); xlabel('n'); grid; pause
b = b .* chebwin(N,100)'; % Chebyshev window with -100 dB side-lobes
stem( n, b ); title('b(n)'); xlabel('n'); grid; pause
