% dsp10_ex_sdr.m - signal resampling in Software Defined Radio
clear all; close all;

FileName = 'SDRSharp_FMRadio_101600kHz_IQ.wav';  T=3;  demod=1; % FMRadio signal

inf = audioinfo(FileName), pause                      % what is "inside" IQ file
fs = inf.SampleRate;                                  % sampling rate
[x,fs] = audioread(FileName,[1,T*fs]);                % read only T seconds 
whos,                                                 % what is in the memory
Nx = length(x),                                       % signal length

% Reconstruct the complex-value IQ data from two-column wav file, if necessary add Q=0
[dummy,M] = size(x);
if(M==2) x = x(:,1) - j*x(:,2); else x = x(1:Nx,1) + j*zeros(Nx,1); end 

bwSERV=200e+3; bwAUDIO=25e+3;                         % FM service and audio frequency bandwidth
D1 = round(fs/bwSERV); D2 = round(bwSERV/bwAUDIO);    % Downsampling ratios
f0 = -0.59e+6; x = x .* exp(-j*2*pi*f0/fs*(0:Nx-1)'); % What station? freq shift to 0 Hz 
x = resample(x,1,D1);                                 % Resample down to service freq
x = real(x(2:end)).*imag(x(1:end-1))-real(x(1:end-1)).*imag(x(2:end)); % FM demodulation
x = resample(x,1,D2);                                 % Resample down to audio freq 
soundsc(x,bwAUDIO);                                   % Listening
