% dsp10_ex_up.m - Signal up-sampling
clear all; close all;

% Input - parameters and signal x
K=5; M=50; N=2*M+1; Nx=1000;               % K - up-sampling ratio
x = sin(2*pi*(0:Nx-1)/100);                % signal to be up-sampled
% [x,fs]=audioread('speech.wav'); x=x(:,1)'; Nx = length(x);  % for further tests
R=rem(Nx,K); x = x(1:end-R); Nx = Nx-R;    % adjusting length to polyphase filtering

% Slow up-sampling (interpolation)
% one convolution of filter weights with zero-inserted signal 
xz = zeros(1,K*Nx);                        % # signal with inserted zeros
xz(1:K:end) = x;                           % #
h = K*fir1(N-1, 1/K, kaiser(N,12));        % interpolattion filter design                
yi = filter(h,1,xz);                       % signal filtering

n = M+1:K:K*Nx-M; ni = N:K*Nx-(K-1);
figure; plot(n,x(M/K+1:Nx-M/K),'ro-',ni-M,yi(ni),'bx'); title('x(n) and yi(n)');
err1 = max(abs(x(M/K+1:Nx-M/K)-yi(ni(1:K:end)))), pause

% Fast polyphase up-sampling (interpolation)
% K convolutions of original signal with K poly-phase filter weight sequences
% signal is not zeros-inserted 
for k=1:K
    yipp(k:K:K*Nx) = filter( h(k:K:end), 1, x);
end
err2 = max(abs(yi-yipp)), pause